﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

class A {
	private int x;

	public int GetX() {
		return x;
	}

	public static void SetXOnB(B b) {
		b.x = 30;
	}

	public static int c;

	private static int d;
}

class B : A {
	public void SetX() {
		// Error: 'A.x' is inaccessible due to its protection level
		// x = 10;
	}

	public void SetD() {
		// Error: 'A.d' is inaccessible due to its protection level
		// d = 10;
	}
}

class Program {
	static void Main(string[] args) {
		//
		// Inheritance of a private member
		//
		B b = new B();
		Console.WriteLine("b.x == {0}", b.GetX());

		A a = new B();
		Console.WriteLine("((A) B).x == {0}", a.GetX());
		A.SetXOnB((B) a);
		Console.WriteLine("((A) B).x == {0}", a.GetX());

		//
		// Inheritance of static members
		//
		B.SetXOnB(new B());
		A.c = 42;
		Console.WriteLine("B.c == {0}", B.c);
		B.c++;
		Console.WriteLine("A.c == {0}", A.c);
	}
}

